/* Do not edit this file. It was automatically genarated. */

#ifndef HEADER_Process
#define HEADER_Process
/*
htop
(C) 2004 Hisham H. Muhammad
Released under the GNU GPL, see the COPYING file
in the source distribution for its full text.
*/

#include "Process.h"
#include "ProcessFilter.h"
#include "Object.h"

#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>

// TODO: wtf!?
int kill(pid_t pid, int signal);

// TODO: can this be really *hardcoded*!?
#define PAGE_SIZE 4

#define PROCESS_COMM_LEN 512
#define PROCESS_USER_LEN 10

typedef struct Process_ {
   Object super;

   ProcessFilter* filter;
   char* displayBuffer;

   int pid;
   char comm[PROCESS_COMM_LEN + 2];
   char state;
   int ppid;
   int pgrp;
   int session;
   int tty_nr;
   int tpgid;
   unsigned long int flags;
   unsigned long int minflt;
   unsigned long int cminflt;
   unsigned long int majflt;
   unsigned long int cmajflt;
   unsigned long int utime;
   unsigned long int stime;
   long int cutime;
   long int cstime;
   long int priority;
   long int nice;
   long int itrealvalue;
   unsigned long int starttime;
   unsigned long int vsize;
   long int rss;
   unsigned long int rlim;
   unsigned long int startcode;
   unsigned long int endcode;
   unsigned long int startstack;
   unsigned long int kstkesp;
   unsigned long int kstkeip;
   unsigned long int signal;
   unsigned long int blocked;
   unsigned long int sigignore;
   unsigned long int sigcatch;
   unsigned long int wchan;
   unsigned long int nswap;
   unsigned long int cnswap;
   int exit_signal;
   int processor;
   int m_size;
   int m_resident;
   int m_share;
   int m_trs;
   int m_drs;
   int m_lrs;
   int m_dt;
   uid_t st_uid;
   float percent_cpu;
   char user[PROCESS_USER_LEN + 1];
} Process;


Process* Process_clone(Process* this);

Process* Process_new(ProcessFilter* filter);

void Process_delete(Process* this);

char* Process_display(Object* cast);

void Process_setPriority(Process* this, int priority);

void Process_sendSignal(Process* this, int signal);

int Process_snprintf(Process* this, char* out, int n, ProcessField field);

int Process_compare(const void* v1, const void* v2);

#endif
