/* Do not edit this file. It was automatically genarated. */

#ifndef HEADER_Vector
#define HEADER_Vector
/*
htop
(C) 2004 Hisham H. Muhammad
Released under the GNU GPL, see the COPYING file
in the source distribution for its full text.
*/

#include "Vector.h"
#include <stdlib.h>
#include <string.h>

typedef void(*Procedure)(void*);
typedef int(*BooleanFunction)(const void*,const void*);

typedef struct Vector_ {
   void **array;
   int arraySize;
   int growthRate;
   int items;
   BooleanFunction compareFunction;
} Vector;


Vector* Vector_new();

void Vector_delete(Vector* v);

void Vector_prune(Vector* v);

Vector* Vector_clone(Vector* v);

int Vector_compareFunction(const void* v1, const void* v2);

void Vector_setCompareFunction(Vector* v, BooleanFunction f);

void Vector_sort(Vector* v);

/* private */
void Vector_checkArraySize(Vector* this);

void Vector_insert(Vector* this, int index, void* data);

void* Vector_remove(Vector* this, int index);

void Vector_set(Vector* v, int index, void* data);

void* Vector_get(Vector* v, int index);

int Vector_size(Vector* v);

void Vector_merge(Vector* v, Vector* v2);

void Vector_add(Vector* v, void* data);

int Vector_indexOf(Vector* v, void* search);

void Vector_foreach(Vector* v, Procedure f);

#endif
